unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OpenGL, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    FDC: HDC;
    FHRC: HGLRC;
    procedure Draw;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Gl;

procedure TForm1.Draw;
var
  Bmp: TBitmap;
  texture: GLuint;
  l, t, w: Integer;
begin
  Bmp := TBitmap.Create;
  Bmp.LoadFromFile(ExtractFilePath(ParamStr(0)) + '1.bmp');
  // 
  glGenTextures(1, @texture);
  // 
  glBindTexture(GL_TEXTURE_2D, texture);
  // ʹλͼͼ
  glTexImage2D(
    GL_TEXTURE_2D,            // һ2D GL_TEXTURE_2D
    0,                        // ͼϸ̶ Ĭ 0
    3,                        // ݵĳɷΪͼɺ죬̣ Ĭ3
    Bmp.Width,                // Ŀ
    Bmp.Height,               // ĸ߶
    0,                        // ߿ֵ Ĭ 0
    GL_BGR_EXT,               // ݸʽ bmpʹ bgr
    GL_UNSIGNED_BYTE,         // ͼ޷ֽ͵
    Bmp.ScanLine[Bmp.Height - 1] // DIBָ
  );
  // openglڷŴԭʼ(GL_TEXTURE_MAG_FILTER)Сԭʼ(GL_TEXTURE_MIN_FILTER)ʱOpenGLõ˲ʽ
  // GL_LINEAR ʹ˲԰ͼƬƽҪڴCPU
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);  // ˲
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);  // ˲

  // ǻͼһıΣͼƬ
  
  // ӳ
  if glIsEnabled(GL_TEXTURE_2D) = 0 then
    glEnable(GL_TEXTURE_2D);
  // ջ
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);  

  l := 10;
  t := 10;
  w := 200; // ŴΪ200*200ͼƬ

  // ѡ ʹöglBegin()  glEnd() ֮
  glBindTexture(GL_TEXTURE_2D, texture);
	glBegin(GL_QUADS);
  // glTexCoord2f ĵһXꡣ
  // 0.0ࡣ 0.5е㣬 1.0Ҳࡣ
  // glTexCoord2f ĵڶYꡣ
  // 0.0ĵײ 0.5е㣬 1.0Ķ
  glTexCoord2f(0, 1);
  glVertex2f(l, t);
  glTexCoord2f(1, 1);
  glVertex2f(l + w, t);
  glTexCoord2f(1, 0);
  glVertex2f(l + w, t + w);
  glTexCoord2f(0, 0);
  glVertex2f(l, t + w);
	glEnd();

  Bmp.Free;
  SwapBuffers(FDC);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
pfd:TPIXELFORMATDESCRIPTOR;
  pixelFormat: Integer;
begin
  With pfd do
  begin
    nSize := sizeof(TPIXELFORMATDESCRIPTOR); // size
    nVersion := 1; // version
    dwFlags := PFD_SUPPORT_OPENGL or PFD_DRAW_TO_WINDOW or PFD_DOUBLEBUFFER; // support double-buffering
    iPixelType := PFD_TYPE_RGBA; // color type
    cColorBits := 24; // preferred color depth
    cRedBits := 0;
    cRedShift := 0; // color bits (ignored)
    cGreenBits := 0;
    cGreenShift := 0;
    cBlueBits := 0;
    cBlueShift := 0;
    cAlphaBits := 0;
    cAlphaShift := 0; // no alpha buffer
    cAccumBits := 0;
    cAccumRedBits := 0; // no accumulation buffer,
    cAccumGreenBits := 0; // accum bits (ignored)
    cAccumBlueBits := 0;
    cAccumAlphaBits := 0;
    cDepthBits := 16; // depth buffer
    cStencilBits := 0; // no stencil buffer
    cAuxBuffers := 0; // no auxiliary buffers
    iLayerType := PFD_MAIN_PLANE; // main layer
    bReserved := 0;
    dwLayerMask := 0;
    dwVisibleMask := 0;
    dwDamageMask := 0;
  end;
  FDC := GetDC(Handle);
  pixelFormat := ChoosePixelFormat(FDC, @pfd);
  if pixelFormat = 0 then
    Exit;
  if not SetPixelFormat(FDC, pixelFormat, @pfd) then
    Exit;
  FHRC := wglCreateContext(FDC);
  wglMakeCurrent(FDC, FHRC);

  // ñɫΪ ɫ Ϊ RGBA
  glClearColor(0, 0, 0, 0);
  // ͼͶӰ任 ͶӰ
  glMatrixMode(GL_PROJECTION);
  // õǰָľΪλ
  glLoadIdentity;
  // ָOpenGLڴڻͼ
  glViewPort(0, 0, ClientWidth, ClientHeight);
  // ϵķΧ
  gluOrtho2D(0, ClientWidth, ClientHeight, 0);
  // 任лΪģͼ任
  glMatrixMode(GL_MODELVIEW);
  // õǰָľΪλ
  glLoadIdentity;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  wglMakeCurrent(FDC, FHRC);
  wglDeleteContext(FHRC);
  ReleaseDC(Handle, FDC);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Draw;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  // ڸıСʱָͼ
  glClearColor(0, 0, 0, 0);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glViewPort(0, 0, ClientWidth, ClientHeight);
  gluOrtho2D(0, ClientWidth, ClientHeight, 0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
end;

end.
